<?php 
// recopharma
// SAEZAM Core v4.0
// Date : 16-05-2014

class recopharma extends saezam{
	var $classe="recopharma";
	var $active=2;
	var $niveau1="";
	var $niveau2="";
	var $niveau3="";
	var $html="";
	var $recherchehtml="";
	var $vok="";
	var $vtravail="";
	var $datajson="";
	
	var $form_1=array(
		array(
		  "titre"			=> "Nom de la recommandation" ,
		  "variable"		=> "nom",
		  "typeinput"		=> "text",
		  "required"		=> true
		),
		array(
		  "titre"			=> "Mots-clés" ,
		  "variable"		=> "tags",
		  "typeinput"		=> "text"
		),
		array(
		  "titre"			=> "Responsable" ,
		  "variable"		=> "auteur",
		  "typeinput"		=> "listeselect",
		  "classe"		=> "user",
		  "variablelabel"	=> "nomjoli",
		  "ordre"			=>	"nomjoli ASC",
		  "variablevalue"=> "serial",
		  "variableselect"=> "id",
		  "variabletotest"=> "auteurid",
		  "noemptychoice" => true,
		  "onlygroup"		=>	10
		),
		array(
		  "titre"			=> "Classement ATC" ,
		  "variable"		=> "niveau1",
		  "typeinput"		=> "listeselect",
		  "classe"			=> "catpharma",
		  "selection"		=>	"WHERE typecat='niveau1'",
		  "orderby"			=>	"nom ASC"
		),
		array(
		  "titre"			=> "Sous-categorie" ,
		  "variable"		=> "niveau2",
		  "typeinput"		=> "listeselect",
		  "classe"			=> "catpharma",
		  "selection"		=>	"WHERE typecat='niveau2'",
		  "orderby"			=>	"nom ASC"
		),
		array(
		  "titre"			=> "Thématique" ,
		  "variable"		=> "niveau3",
		  "typeinput"		=> "listeselect",
		  "classe"			=> "catpharma",
		  "selection"		=>	"WHERE typecat='niveau3'",
		  "orderby"			=>	"nom ASC"
		),
		array(
						"titre"			=> "État" ,
						"variable"		=> "active",
						"typeinput"		=> "select",
						"options"		=> array(
							 array(
								   "titre" 	=> "Hors ligne",
								   "value" 	=> "0"
								   ),
							 array(
								   "titre" 	=> "En ligne",
								   "value" 	=> "1"
								   ),
							 array(
								   "titre" 	=> "A valider",
								   "value" 	=> "2"
								   )
						)
		)
	);
	var $form_tags=array(
		array(
		  "titre"			=> "Mots-clés" ,
		  "variable"		=> "tags",
		  "typeinput"		=> "text"
		)
	);
	
	function creernotif($sujet,$message,$only=false){
		global $proprio;
		//recup des suiveurs
		$ls=new liste;
		$ls->type="suivipharma";
		$ls->getFastList("WHERE reco='$this->serial'","user","obj");
		
		if($only=="admins"){
			$destis=array();
			$la=new liste;
			$la->type="user";
			$la->getFastList("WHERE groupeid>='10'","serial","obj");
			foreach($la->liste as $a){
				$destis[]=$a->serial;	
			}
		}
		if($only=="contributeurs"){
			$destis=array();
			$la=new liste;
			$la->type="user";
			$la->getFastList("WHERE groupeid='3'","serial","obj");
			foreach($la->liste as $a){
				$destis[]=$a->serial;	
			}
		}
		if($only=="adminscontributeurs"){
			$destis=array();
			$la=new liste;
			$la->type="user";
			$la->getFastList("WHERE groupeid>='3'","serial","obj");
			foreach($la->liste as $a){
				$destis[]=$a->serial;	
			}
		}
		foreach($ls->liste as $s){
			if($only!=false and array_search($s->user,$destis)===false){
				continue;
			}
			$notif=new notifpharma;
			$notif->user=$s->user;
			$notif->sujet=$sujet;
			$notif->html=$message;
			$notif->idcible=$this->id;
			$notif->classecible=$this->classe;
			$notif->save();
		}
	}
	
	function verifsinotifscontribs($lu,$r=false){
		if($r!=false){
			$this->serial=$r->serial;
			$this->niveau1=$r->niveau1;
		}
		$niveau1=new catpharma;
		$niveau1->serial=$this->niveau1;
		$niveau1->getInfo();
		foreach($lu->liste as $u){
			$temp=explode(",",$u->niveaux);
			if($temp==array("")){continue;}
			if(array_search($niveau1->id,$temp)===false){continue;}
			echo "<br>$u->nomjoli => ".$niveau1->id." ".print_r($temp,true);
			$ls=new liste;
			$ls->type="suivipharma";
			$ls->getList("WHERE reco='$this->serial' AND user='$u->serial'");
			if($u->active==1){
				if(empty($ls->liste)){
					$s=new suivipharma;
					$s->user=$u->serial;
					$s->reco=$this->serial;
					$s->save();
				}
			}else if($u->active==0){
				if(!empty($ls->liste)){
					foreach($ls->liste as $s){
						$s->supprimer();	
					}
				}
			}
		}
	}
	
	function aftersavephp(){
		global $siteInfo;
		$this->getInfo();
		$this->collectdata();
		
		$sujet="[PharmaReco] Recommandation mise à jour";	
		$message="<b>La recommandation '$this->nom' a été mise à jour.</b><br><br>Vous pouvez y accéder en cliquant sur le lien suivant : <br>".$this->url;
		
		$this->creernotif($sujet,$message);
	}
	
	function getScore(){
		global $currentUser;
		$ls=new liste;
		$ls->type="scorepharma";	
		$ls->getFastList("WHERE reco='$this->serial'","score,auteurid","obj");
		$pos=0;
		$neg=0;
		$currentUserchoice=false;
		foreach($ls->liste as $s){
			if($s->score>0){
				$pos++;
				if(isset($currentUser) and $s->auteurid==$currentUser->id){
					$currentUserchoice="pos";
				}
			}else{
				$neg++;	
				if(isset($currentUser) and $s->auteurid==$currentUser->id){
					$currentUserchoice="neg";
				}
			}
		}
		return array(
			"pos"	=>	$pos,
			"neg"	=>	$neg,
			"currentUserchoice"	=>	$currentUserchoice
		);
	}
	
	function newnotation($user,$score){
		$ls=new liste;
		$ls->type="scorepharma";
		$ls->getList("WHERE user='$user->serial' AND reco='$this->serial'");
		foreach($ls->liste as $s){
			$s->supprimer();
		}
		$s=new scorepharma;
		$s->score=$score;
		$s->user=$user->serial;
		$s->reco=$this->serial;
		$s->save();
	}
	
	function notation($readonly=true,$score=false){
		global $siteInfo;
		global $currentUser;
		if($score==false){
			$score=$this->getScore();
		}
		?>
        <a href="#" class="noteok flaticon-hand226 <?php if($score["currentUserchoice"]=="pos"){echo "selected";}?>" onclick="setnotation(this,'1','<?php echo $this->serial;?>');return false;"></a>
        <span class="noteok"><?php echo $score["pos"];?></span>
        <a href="#" class="noteko flaticon-hand226 <?php if($score["currentUserchoice"]=="neg"){echo "selected";}?>" onclick="setnotation(this,'0','<?php echo $this->serial;?>');return false;"></a>
        <span class="noteko"><?php echo $score["neg"];?></span>
        <script>
            function setnotation(cible,score,serial){
				<?php if(!isset($currentUser)){?>
					alert("Désolé, mais vous devez d'abord créer un compte.");
				<?php }else{?>
					$(".flaticon-hand226").removeClass("selected");
					$(cible).addClass("selected");
					var json={
						"action" :"setnotation",
						"serial" : serial,
						"score" : score
					};
					$.ajax({
						   type: "POST",
						   url: "<?php echo $siteInfo->templateurl;?>/php/logi.php",
						   data : json,
						   dataType: "json",
						   success: function(msg){
							  $("span.noteok").html(msg.score.pos);
							  $("span.noteko").html(msg.score.neg);
						 }
					});
				<?php }?>
            }
        </script>
        <?php
	}
	
	function demarrersuivi($user){
		$ls=new liste;
		$ls->type="suivipharma";
		$ls->countList("WHERE user='$user->serial' AND reco='$this->serial'");
		if($ls->nombre==0){
			$s=new suivipharma;
			$s->user=$user->serial;
			$s->reco=$this->serial;
			$s->save();
		}
	}
	
	function arretersuivi($user){
		$ls=new liste;
		$ls->type="suivipharma";
		$ls->getList("WHERE user='$user->serial' AND reco='$this->serial'");
		foreach($ls->liste as $s){
			$s->supprimer();
		}
	}
	
	function hassuivi($user){
		$ls=new liste;
		$ls->type="suivipharma";
		$ls->countList("WHERE user='$user->serial' AND reco='$this->serial'");
		if($ls->nombre==0){
			return false;
		}else{
			return true;	
		}
	}
	
	function getdiagrams(){
		global $siteInfo;
		global $currentUser;
		$isadmin=false;
		if(isset($currentUser) and $currentUser->groupeid>=3){
			$isadmin=true;
		}
		$ll=new liste;
		$ll->type="logipharma";
		$ll->getList("WHERE reco='$this->serial' ORDER BY date_modif DESC");
		
		$vtravail=false;
		$vok=false;
		$errors=array();
		if(empty($ll->liste)){
			$errors[]="Aucun logigramme enregistré pour cette recommandation";
		}else{
			foreach($ll->liste as $l){
				if($this->vok==$l->serial){
					$vok=$l;
				}
			}
			foreach($ll->liste as $l){
				if($this->vtravail==$l->serial){
					$vtravail=$l;
				}
			}
			if($vtravail==false){
				$errors[]="Aucune version de travail";
			}
			if($vok==false){
				$errors[]="Aucune version validée";
			}
		}
		if($isadmin){?>
			<div class="undemi">
				<h2>Version validée</h2>
				<?php if($vok!=false){?>
					<?php echo $vok->afficher(false);?>
				<?php }else{
						echo "(aucune version validée)";
				}?>
			</div>
			<div class="undemi">
				<h2>Version de travail</h2>
				<div id="zonetravail">
				<?php if($vtravail!=false){
					echo $vtravail->afficher(true);
					
					if(isset($currentUser) and $currentUser->groupeid>=10){
					?>
					<div class="bouton"><a href="#" class="bouton" data-logipharma="<?php echo $vtravail->serial;?>" onclick="validerlogipharma(this);return false;">Valider ce logigramme</a></div>
					<?php 
					}
				}else{
					echo "(aucune version de travail)";
					?>
					<div class="bouton"><a href="#" class="bouton" onclick="createlogipharma('<?php echo $this->serial;?>',true);return false;">Créer une version de travail</a></div>
					<?php 
				}?>
				</div>
			</div>
			<div>
				<h2>Historique des versions</h2>
                <table id="versionlogi">
                	<tr><th>Aperçu</th><th>Date</th><th>Contributions</th><th>Actions</th></tr>

                    <?php if($vok!=false){
						$vok->getlinetableau(false,"v. validée");
					}?>
                    <?php if($vtravail!=false){
						$vtravail->getlinetableau(true,"v. travail");
					}?>
                    <?php foreach($ll->liste as $l){
						if(($vok==false or $l->id!=$vok->id) and ($vtravail==false or $l->id!=$vtravail->id)){
							$l->getlinetableau(true);
						}
					}?>
                </table>
                <div class="bouton">
                	<a href="#" class="bouton" onclick="createlogipharma('<?php echo $this->serial;?>',false);return false;">Proposer une nouvelle version</a>
                </div>
			</div>
		<?php }else{
			if($vok!=false){
				echo $vok->afficher(false);
			}else{
				echo "(pas de diagramme pour cette recommandation)";	
			}
		}	
	}
	
	function aftergetInfo(){
		global $siteInfo;
		$this->url=$siteInfo->url."/recommandations/".$this->nomurl;
	}
	
	function collectdata(){
		$n1=new catpharma;
		$n1->serial=$this->niveau1;
		$n1->getInfo();
		
		$n2=new catpharma;
		$n2->serial=$this->niveau2;
		$n2->getInfo();
		
		$n3=new catpharma;
		$n3->serial=$this->niveau3;
		$n3->getInfo();
		
		$l=new logipharma;
		$l->serial=$this->vok;
		$l->getInfo();
		
		$score=$this->getScore();
		
		$dataaffichage=array();
		$dataaffichage["arborescence"]="";
		if($n1->nom!=""){
			$dataaffichage["arborescence"]="<span>$n1->nom</span> <span>$n2->nom</span> <span>$n3->nom</span>";
		}else if($n2->nom!=""){
			$dataaffichage["arborescence"]="<span>$n2->nom</span> <span>$n3->nom</span>";
		}else if($n3->nom!=""){
			$dataaffichage["arborescence"]="<span>$n3->nom</span>";
		}
		$dataaffichage["html"]=$l->html;
		$dataaffichage["notation"]='<a href="#" class="noteok flaticon-hand226" onclick="return false;"></a>
        <span class="noteok">'.$score["pos"].'</span>
        <a href="#" class="noteko flaticon-hand226" onclick="return false;"></a>
        <span class="noteko">'.$score["neg"].'</span>';
		$dataaffichage["date"]=$l->date_modif;
		
		$this->datajson=json_encode($dataaffichage);
		$this->save();
	}
	
	function htmlliste($classe){
		global $currentUser ;
		global $siteInfo;
		$dataaffichage=json_decode($this->datajson,true);
		?>
        <div class="recoliste <?php echo $classe;?>">
        	<div class="troisquart">
                <h3>
                    <a href="<?php echo $this->url;?>"><?php echo $this->nom;?></a>
                </h3>
				<div class="arborescence">
                	<?php echo $dataaffichage["arborescence"];?>
                </div>           
            </div>
            <div class="unquart">
            	<div class="notation">
                	<?php echo $dataaffichage["notation"];?>
                </div>
                <div class="date">
                	<?php if(is_numeric($dataaffichage["date"])){echo date("d-m-Y",$dataaffichage["date"]);}else{echo "-";}?>
                </div>
            </div>
            <?php if(isset($currentUser) and $currentUser->groupeid>1){?>
            <div class="statut active<?php echo $this->active;?>">
            	<?php switch($this->active){
					case 1 :
						echo "Recommandation validée et visible par les internautes";
					break;
					case 2 :
						echo "Recommandation à valider et non-visible par les internautes";
					break;
					case 0 :
						echo "Recommandation non-visible par les internautes";
					break;
				}?>
            </div>
            <?php }?>
        </div>
        <?php 
	}
	
	function htmllistesimple($classe){
		global $currentUser ;
		global $siteInfo;
		$dataaffichage=json_decode($this->datajson,true);
		?>
        <div class="recoliste simple <?php echo $classe;?>">
            <h3>
                <a href="<?php echo $this->url;?>"><?php echo $this->nom;?></a>
            </h3> 
            <div class="notation undemi">
				<?php echo $dataaffichage["notation"];?>
            </div>
            <div class="date undemi">
                <?php if(is_numeric($dataaffichage["date"])){echo date("d-m-Y",$dataaffichage["date"]);}else{echo "-";}?>
            </div>
            <?php if(isset($currentUser) and $currentUser->groupeid>1){?>
            <div class="statut active<?php echo $this->active;?>">
            	<?php switch($this->active){
					case 1 :
						echo "Recommandation validée et visible par les internautes";
					break;
					case 2 :
						echo "Recommandation à valider et non-visible par les internautes";
					break;
					case 0 :
						echo "Recommandation non-visible par les internautes";
					break;
				}?>
            </div>
            <?php }?>
        </div>
        <?php 
	}
	
	function htmlzoom($instance){
		global $currentUser ;
		global $siteInfo;
		
		$isadmin=false;
		if(isset($currentUser) and $currentUser->groupeid>=2){
			$isadmin=true;
		}
		
		$n1=new catpharma;
		$n1->serial=$this->niveau1;
		$n1->getInfo();
		
		$n2=new catpharma;
		$n2->serial=$this->niveau2;
		$n2->getInfo();
		
		$n3=new catpharma;
		$n3->serial=$this->niveau3;
		$n3->getInfo();
		
		$etat="ok";
		
		$ll=new liste;
		$ll->type="logipharma";
		$ll->getList("WHERE reco='$this->serial' ORDER BY date_crea DESC");
		
		$vtravail=false;
		$vok=false;
		$errors=array();
		if(empty($ll->liste)){
			$errors[]="Aucun logigramme enregistré pour cette recommandation";
		}else{
			foreach($ll->liste as $l){
				if($this->vok==$l->serial){
					$vok=$l;
				}
			}
			foreach($ll->liste as $l){
				if($this->vtravail==$l->serial){
					$vtravail=$l;
				}
			}
			if($vok==false){
				$errors[]="Aucune version validée";
			}
		}
		
		?>
        <div class="textes recopharmazoom">
            <h1><?php echo $this->nom;?> <?php if($isadmin){?>
        		<a href="<?php echo $siteInfo->url;?>/core/form/ajax.php?type=recopharma&action=edit&serial=<?php echo $this->serial;?>" class="lightboxhtml" title="Modifier la recommandation"><img src="<?php echo $siteInfo->url;?>/core/images/pictos/prefs.gif"></a>
				<a href="#" class="supprimer" onclick="supprimer('recopharma','<?php echo $this->serial;?>','cette recommandation');return false;" title="Supprimer cette recommandation"><img alt="Supprimer" src="<?php echo $siteInfo->url;?>/core/images/pictos/delete.gif"></a>
				<?php }?>
                <div class="liens">
                	<?php if(isset($currentUser)){?>
						<?php if($this->hassuivi($currentUser)){?>
                            <a href="#" onclick="suivrelogipharma('<?php echo $this->serial;?>',0);return false;" class="bouton">Suivie</a>			
                        <?php }else{?>
                            <a href="#" onclick="suivrelogipharma('<?php echo $this->serial;?>',1);return false;" class="bouton">Suivre</a>
                        <?php }?>
                    <?php }?>
                    <a href="<?php echo $siteInfo->templateurl;?>/php/fichepdf.php?reco=<?php echo $this->serial;?>" class="bouton externe">Télécharger</a>
                </div>
             	   
             </h1>
                <?php if($n1->serial!="" or $n2->serial!="" or $n3->serial!=""){?>
            <div class="arborescence">
				<?php if($n1->nom!=""){?>
                    <a href="<?php echo $siteInfo->url;?>/recommandations/niveau1:<?php echo $n1->serial;?>"><?php echo $n1->nom;?></a>
                <?php }?>
				<?php if($n2->nom!=""){?>
                	<a href="<?php echo $siteInfo->url;?>/recommandations/niveau2:<?php echo $n2->serial;?>"><?php echo $n2->nom;?></a>
                <?php }?>
				<?php if($n3->nom!=""){?>
                	<a href="<?php echo $siteInfo->url;?>/recommandations/niveau3:<?php echo $n3->serial;?>"><?php echo $n3->nom;?></a>
                <?php }?>
            </div>
            <?php }?>
							
            <div class="untiers enhaut">
            	<?php 
				if(!isset($currentUser)){
					$this->notation(true);
				}else{
					$this->notation(false);
				}
				?>
            </div>
            <div class="untiers enhaut ref">
            	référence <b><?php echo $this->id;?>-PHARMA</b>
            </div>
            <?php if(isset($currentUser) and $currentUser->groupeid>1){?>
            <div class="statut active<?php echo $this->active;?>">
            	<?php switch($this->active){
					case 1 :
						echo "Recommandation validée et visible par les internautes";
					break;
					case 2 :
						echo "Recommandation à valider et non-visible par les internautes";
					break;
					case 0 :
						echo "Recommandation non-visible par les internautes";
					break;
				}?>
            </div>
            <?php }?>
            <?php if(!empty($errors)){
				echo "<ul class='errorsul'>";
				foreach($errors as $error){
					echo "<li>$error</li>";
            	}
				echo "</ul>";
			}?>
            <div class="diagrams">
            	<?php $this->getdiagrams();?>
            </div>
            <?php if($vok!=false){
				$tags=explode(",",$vok->tags);
				if((!empty($tags) and $tags!=array("")) or (isset($currentUser) and $currentUser->groupeid>=3)){?>
                    <div class="html tags">
                        <h2>Mots-clés  <?php if($isadmin){?>
                        <a href="<?php echo $siteInfo->url;?>/core/form/ajax.php?type=logipharma&action=edit&serial=<?php echo $vok->serial;?>" class="lightboxhtml" title="Modifier le logigramme"><img src="<?php echo $siteInfo->url;?>/core/images/pictos/prefs.gif"></a><?php }?></h2>
                        <?php 
                        foreach($tags as $tag){
                            if(trim($tag)==""){continue;}
                            $tag=trim($tag);
                            ?>
                            <span class="tag"><a href="<?php echo $siteInfo->url;?>/recommandations/cherche:<?php echo $tag;?>"><?php echo $tag;?></a></span> 
                            <?php 
                        }?>
                    </div>
            	<?php }
				if($vok->html!="" or (isset($currentUser) and $currentUser->groupeid>=3)){?>
                <div class="html">
                    <h2>Description <?php if($isadmin){?>
                    <a href="<?php echo $siteInfo->url;?>/core/form/ajax.php?type=logipharma&action=edit&serial=<?php echo $vok->serial;?>" class="lightboxhtml" title="Modifier le logigramme"><img src="<?php echo $siteInfo->url;?>/core/images/pictos/prefs.gif"></a><?php }?></h2>
                    <?php echo $vok->html;?>
                </div>
            	<?php }
				if($vok->sourceshtml!="" or (isset($currentUser) and $currentUser->groupeid>=3)){?>
                <div class="html">
                    <h2>Sources <?php if($isadmin){?>
                    <a href="<?php echo $siteInfo->url;?>/core/form/ajax.php?type=logipharma&action=edit&serial=<?php echo $vok->serial;?>" class="lightboxhtml" title="Modifier le logigramme"><img src="<?php echo $siteInfo->url;?>/core/images/pictos/prefs.gif"></a><?php }?></h2>
                    <?php echo $vok->sourceshtml;?>
                </div>
            	<?php }?>
                
                <?php 
				$hs=json_decode($vok->history);
				$contributeurs=array();
				foreach($hs as $h){
					$contributeurs[$h->auteur]="id='$h->auteur'";
				}
				$i=0;
				$lc=new liste;
				$lc->type="userpharma";
				$lc->getList("WHERE (".implode(" OR ",$contributeurs).")","nomjoli","obj");
				if(!empty($lc->liste)){
					echo "<h2>Ils ont contribués à cette recommandation</h2>";	
				}
				foreach($lc->liste as $c){
					$c->htmlliste(false);
				}
				?>
                
                
            <?php }?>
            
            <div class="undemi" id="discussionpubliquediv">
            	<h2>Discussion publique</h2>
                <div class="listediscussion" id="listediscussionpublique">
                
                </div>
                <div class="bouton">
                	<div class="image">
                    
                    </div>
                    <form id="listediscussionpubliqueform">
                        <textarea placeholder="Ecrivez un message" id="listediscussionpubliquetext">
                        
                        </textarea>
                        <a href="#" onclick="discussionpubliquesend();return false;" class="bouton">Envoyer</a>
                    </form>
                </div>
            </div>
            <?php if($isadmin){?>
            <div class="undemi" id="discussionadmindiv">
            	<h2>Discussion admin</h2>
                <div class="listediscussion" id="listediscussionadmin">
                
                </div>
                <div class="bouton">
                	<div class="image">
                    
                    </div>
                    <form id="listediscussionadminform">
                        <textarea placeholder="Ecrivez un message" id="listediscussionadmintext">
                        
                        </textarea>
                        <a href="#" onclick="discussionadminsend();return false;" class="bouton">Envoyer</a>
                        <a href="#" onclick="sollicitercontributeurs();return false;" class="bouton">Solliciter contributeurs</a>
                        <a href="#" onclick="solliciteradmins();return false;" class="bouton">Solliciter admins</a>
                    </form>
                </div>
            </div>
            <?php }?>
        </div>
	<script type="text/javascript">
	
	//DISCUSSION PUBLIQUE 
	function discussionpubliquesend(){
		<?php if(!isset($currentUser)){?>
		alert("Désolé, mais vous devez d'abord créer un compte");
		<?php }else{?>
		$.ajax({
			   type: "POST",
			   data : "text="+encodeURIComponent($("#listediscussionpubliquetext").val()),
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=send&type=publique&cible=<?php echo $this->id;?>",
			   dataType: "json",
			   success: function(msg){
				   discussionpubliquerefresh();
			   }
		});
		<?php }?>
	}
	function discussionpubliquerefresh(){
		$.ajax({
			   type: "GET",
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=refresh&type=publique&cible=<?php echo $this->id;?>",
			   dataType: "html",
			   success: function(msg){
				   $("#listediscussionpublique").html(msg);
				   initialiserliens("#listediscussionpublique");
			   }
		});
	}
	function loadmorepublique(date){
		$.ajax({
			   type: "GET",
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=loadmore&type=publique&cible=<?php echo $this->id;?>&date="+date,
			   dataType: "html",
			   success: function(msg){
				   $("#listediscussionpublique").prepend(msg);
			   }
		});
	}
	discussionpubliquerefresh();
	
	//DISCUSSION ADMIN 
	
	function discussionadminsend(){
		$.ajax({
			   type: "POST",
			   data : "text="+encodeURIComponent($("#listediscussionadmintext").val()),
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=send&type=admin&cible=<?php echo $this->id;?>",
			   dataType: "json",
			   success: function(msg){
				   discussionadminrefresh();
			   }
		});
	}
	function discussionadminrefresh(){
		$.ajax({
			   type: "GET",
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=refresh&type=admin&cible=<?php echo $this->id;?>",
			   dataType: "html",
			   success: function(msg){
				   $("#listediscussionadmin").html(msg);
				   initialiserliens("#listediscussionadmin");
			   }
		});
	}
	function loadmoreadmin(date){
		$.ajax({
			   type: "GET",
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=loadmore&type=admin&cible=<?php echo $this->id;?>&date="+date,
			   dataType: "html",
			   success: function(msg){
				   $("#listediscussionadmin").prepend(msg);
			   }
		});
	}
	
	function sollicitercontributeurs(){
		$.ajax({
			   type: "POST",
			   data : "text="+encodeURIComponent($("#listediscussionadmintext").val())+"&sollicitercontributeurs=1",
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=send&type=admin&cible=<?php echo $this->id;?>",
			   dataType: "json",
			   success: function(msg){
				   discussionadminrefresh();
			   }
		});
	}
	
	function solliciteradmins(){
		$.ajax({
			   type: "POST",
			   data : "text="+encodeURIComponent($("#listediscussionadmintext").val())+"&solliciteradmins=1",
			   url: "<?php echo $siteInfo->templateurl;?>/php/discussion.php?action=send&type=admin&cible=<?php echo $this->id;?>",
			   dataType: "json",
			   success: function(msg){
				   discussionadminrefresh();
			   }
		});
	}
	discussionadminrefresh();
	
	
	
	
	
	//LOGI
	
		function createlogipharma(serial,istravail,cible){
			var datastring={"action"	:	"createlogi","serial"	:	serial,"istravail"	:	istravail};
			if(typeof(cible)!="undefined"){
				datastring["contenu"]=$(cible).parents("tr").find("img.apercu").attr("src");
			}
			$.ajax({
				   type: "POST",
				   url: "<?php echo $siteInfo->templateurl;?>/php/logi.php",
				   data : datastring,
				   dataType: "json",
				   success: function(msg){
					   refreshlogipharma(<?php echo $this->id;?>);
				 }
			});
		}
		
		function suivrelogipharma(serial,state){
			var json={
				"action" :"suivrelogi",
				"serial" : serial,
				"state" : state
			};
			$.ajax({
				   type: "POST",
				   url: "<?php echo $siteInfo->templateurl;?>/php/logi.php",
				   data : json,
				   dataType: "html",
				   success: function(msg){
					  reloadPage();
				 }
			});
		}
		
		function savelogipharma(serial,contenu,xml){
			var json={
				"action" :"savelogi",
				"serial" : serial,
				"contenu" : contenu,
				"xml" : xml
			};
			$.ajax({
				   type: "POST",
				   url: "<?php echo $siteInfo->templateurl;?>/php/logi.php",
				   data : json,
				   dataType: "json",
				   success: function(msg){
					  refreshlogipharma(<?php echo $this->id;?>);
				 }
			});
		}
		
		function travaillogipharma(cible){
			$.ajax({
				   type: "POST",
				   url: "<?php echo $siteInfo->templateurl;?>/php/logi.php",
				   data : "action=travaillogi&reco=<?php echo $this->serial;?>&serial="+$(cible).attr("data-logipharma"),
				   dataType: "html",
				   success: function(msg){
					   refreshlogipharma(<?php echo $this->id;?>);
				 }
			});
		}
		
		function validerlogipharma(cible){
			$.ajax({
				   type: "POST",
				   url: "<?php echo $siteInfo->templateurl;?>/php/logi.php",
				   data : "action=validerlogi&reco=<?php echo $this->serial;?>&serial="+$(cible).attr("data-logipharma"),
				   dataType: "html",
				   success: function(msg){
					   refreshlogipharma(<?php echo $this->id;?>);
				 }
			});
		}
		
		function refreshlogipharma(id){
			$.ajax({
				   type: "GET",
				   url: "<?php echo $siteInfo->templateurl;?>/php/logi.php?action=refresh&id="+id,
				   dataType: "html",
				   success: function(msg){
						$("div.diagrams").html(msg);
						initialiserliens("div.diagrams");
				 }
			});
		}
	
		<?php $clibs=array();
		$temp=explode(",",$siteInfo->librariedrawio);
		$i=1;
		foreach($temp as $tem){
			$f=new fichier;	
			$f->id=$tem;
			$f->getInfo();
			if($i==1){
				$root="/var/www/saezam-clients/pharma2/www/dossiers/racine/libraries/Pharmareco";
				$url="$siteInfo->url/dossiers/racine/libraries/Pharmareco";
			}else{
				$root="/var/www/saezam-clients/pharma2/www/dossiers/racine/libraries/Pharmareco".$i;
				$url="$siteInfo->url/dossiers/racine/libraries/Pharmareco".$i;
			}
			copy($f->root,$root);
			$clibs[]="U".urlencode($url);
			$i++;
		}
		?>
		var editor = 'https://www.draw.io/?embed=1&ui=atlas&spin=1&proto=json&clibs=<?php echo implode(";",$clibs);?>';
		var initial = null;
		var name = null;
		
		var currentlogipharma=false;

		function edit(image)
		{
			currentlogipharma=$(image).attr("data-logipharma");
			var iframe = document.createElement('iframe');
			iframe.setAttribute('frameborder', '0');
			iframe.setAttribute('id', 'drawiframe');

			var close = function()
			{
				window.removeEventListener('message', receive);
				document.body.removeChild(iframe);
			};

			var draft = localStorage.getItem('.draft-' + name);
						
			if (draft != null)
			{
				draft = JSON.parse(draft);
							
				if (!confirm("A version of this page from " + new Date(draft.lastModified) + " is available. Would you like to continue editing?"))
				{
					draft = null;
				}
			}
			
			var receive = function(evt)
			{
				if (evt.data.length > 0)
				{
					var msg = JSON.parse(evt.data);
					
					if (msg.event == 'init')
					{
						if (draft != null)
						{
							iframe.contentWindow.postMessage(JSON.stringify({action: 'load',
								autosave: 1, xml: draft.xml}), '*');
							iframe.contentWindow.postMessage(JSON.stringify({action: 'status',
								modified: true}), '*');
						}
						else
						{
							iframe.contentWindow.postMessage(JSON.stringify({action: 'load',
								autosave: 1, xmlpng: image.getAttribute('src')}), '*');
						}
					}
					else if (msg.event == 'export')
					{
						console.log("EXPORT");
						console.log(msg);
						image.setAttribute('src', msg.data);
						savelogipharma(currentlogipharma,msg.data,msg.xml);
						localStorage.setItem(name, JSON.stringify({lastModified: new Date(), data: msg.data}));
						localStorage.removeItem('.draft-' + name);
						draft = null;
						close();
					}
					else if (msg.event == 'autosave')
					{
						localStorage.setItem('.draft-' + name, JSON.stringify({lastModified: new Date(), xml: msg.xml}));
					}
					else if (msg.event == 'save')
					{
						iframe.contentWindow.postMessage(JSON.stringify({action: 'export',
							format: 'xmlpng', xml: msg.xml, spin: 'Updating page'}), '*');
						localStorage.setItem('.draft-' + name, JSON.stringify({lastModified: new Date(), xml: msg.xml}));
					}
					else if (msg.event == 'exit')
					{
						localStorage.removeItem('.draft-' + name);
						draft = null;
						close();
					}
				}
			};

			window.addEventListener('message', receive);
			iframe.setAttribute('src', editor);
			document.body.appendChild(iframe);
		};
				
		function load()
		{
			initial = document.getElementById('image').getAttribute('src');
			start();
		};
		
		function start()
		{
			name = (window.location.hash.length > 1) ? window.location.hash.substring(1) : 'default';
			var current = localStorage.getItem(name);
		
			if (current != null)
			{
				var entry = JSON.parse(current);
				document.getElementById('image').setAttribute('src', entry.data);
			}
			else
			{
				document.getElementById('image').setAttribute('src', initial);
			}
		};
		
		window.addEventListener('hashchange', start);
	</script>
        <?php 
	}
	
	function classeList($l){
		global $siteInfo;
		global $currentUser;
		?>
        <a href="<?php echo $siteInfo->url;?>/recommandations/<?php echo $l->id;?>" class="bouton">Voir</a>
        <?php if(isset($currentUser) and $currentUser->groupeid>=10){?>
        <a href="<?php echo $siteInfo->url;?>/core/form/ajax.php?type=recopharma&action=edit&serial=<?php echo $l->serial;?>" class="bouton lightboxhtml">Modifier</a>
        <?php }?>
        <?php 	
	}
}

?>